import random

from axipy import Schema, Attribute, CoordSystem, provider_manager, Point, Feature


class TableCache:
    def __init__(self,out_tab,size_cache=100):
        self.__table=out_tab
        self.__size_cache=size_cache
        self.__cache=[]
    def insert(self,ft_insert):

        self.__cache.append(ft_insert)
        if len(self.__cache)>self.__size_cache:
            self.__table.insert(self.__cache)
            self.__cache.clear()
    def end(self):
        if len(self.__cache) > 0:
            self.__table.insert(self.__cache)
            self.__cache.clear()
path_tab=r"E:\Support\AxiomaSupport\Pikets\temp.tab"
schema = Schema(

    Attribute.integer('id'),

    coordsystem=CoordSystem.from_epsg(4326)
)
definition = {
    'src': path_tab,
    'schema': schema
}
table = provider_manager.create(definition)
cls_cache=TableCache(table)
count_record=1000
for i in range(count_record):
    x= random.randrange(-180, 180)
    y = random.randrange(-180, 180)
    pt=Point(x,y)
    ft=Feature({"id":i},geometry=pt)
    cls_cache.insert(ft)
cls_cache.end()
table.commit()
table.close()
provider_manager.tab.remove_table_files(path_tab)
print("End")